<template>
  <div
    v-if="rule"
    class="ext-query-builder-rule bg-grey-1 mt-2x bd-rds-sm p-3x"
  >
    <div class="row row-xs items-center">
      <div class="col">
        <label class="ext-form-label" :title="'inputType: ' + rule.inputType">{{
          rule.label
        }}</label>
      </div>

      <div v-if="!disable" class="col">
        <b-select
          v-if="rule && rule.operators && rule.operators.length"
          v-model="query.operator"
          @change="updateQuery"
        >
          <b-option
            v-for="operator in rule.operators"
            :key="operator.key"
            :value="operator.key"
            :label="operator.value"
          >
          </b-option>
        </b-select>
      </div>
      <div v-else class="col">
        <label class="ext-form-label" title="Operator">{{
          rule.operators.find((r) => r.key == query.operator).value
        }}</label>
      </div>

      <div class="col">
        <!-- Basic text input -->
        <b-input
          v-if="rule.inputType === 'text' && !disable"
          v-model="query.fromValue"
          type="text"
          :placeholder="labels.textInputPlaceholder"
          :error="$validationMessage('value', $v.query.fromValue)"
          @change="updateQuery"
        />
        <label
          v-if="rule.inputType === 'text' && disable"
          class="ext-form-label"
          title="Operator"
          >{{ query.fromValue }}</label
        >

        <!-- Basic number input -->
        <b-numeric-input
          v-if="rule.inputType === 'number' && !disable"
          v-model="query.fromValue"
          type="number"
          :min="0"
          :error="$validationMessage('value', $v.query.fromValue)"
          @change="updateQuery"
        />
        <label
          v-if="rule.inputType === 'number' && disable"
          class="ext-form-label"
          title="Operator"
          >{{ query.fromValue }}</label
        >

        <!-- Datepicker -->
        <b-date-picker
          v-if="rule.inputType === 'date' && !disable"
          v-model="query.fromValue"
          :error="$validationMessage('value', $v.query.fromValue)"
          @change="updateQuery"
        />
        <label
          v-if="rule.inputType === 'date' && disable"
          class="ext-form-label"
          title="Operator"
          >{{ query.fromValue | moment('MM/DD/YYYY') }}</label
        >

        <!-- Radio -->
        <b-radio-group
          v-if="rule.inputType === 'radio' && !disable"
          v-model="query.fromValue"
          @change="updateQuery"
        >
          <b-radio-button
            v-for="(choice, i) in rule.choices"
            :key="i"
            :label="choice.value"
            >{{ choice.label }}</b-radio-button
          >
        </b-radio-group>
        <b-button
          v-if="rule.inputType === 'radio' && disable"
          primary
          small
          disabled
          style="opacity: 1"
        >
          {{ rule.choices.find((item) => item.value == query.fromValue).label }}
        </b-button>

        <!-- Single Checkbox input -->
        <div style="display: flex; justify-content: center">
          <b-checkbox
            v-if="rule.inputType === 'checkbox' && !disable"
            v-model="query.fromValue"
          ></b-checkbox>
        </div>
        <div style="display: flex; justify-content: center">
          <b-checkbox
            v-if="rule.inputType === 'checkbox' && disable"
            v-model="query.fromValue"
            disabled
            style="opacity: 1"
          ></b-checkbox>
        </div>

        <!-- <template v-if="rule.inputType === 'checkbox'">
          <div
            v-for="choice in rule.choices"
            :key="choice.value"
            class="ext-form-control"
          >
            <input
              :id="
                'depth' + depth + '-' + rule.id + '-' + index + '-' + choice.value
              "
              v-model="query.value"
              type="checkbox"
              :value="choice.value"
              class="form-check-input"
            />
            <label
              class="form-check-label"
              :for="
                'depth' + depth + '-' + rule.id + '-' + index + '-' + choice.value
              "
            >
              {{ choice.label }}
            </label>
          </div>
        </template> -->

        <!-- Select without groups -->
        <b-select
          v-if="
            (rule.inputType === 'select' ||
              rule.inputType === 'multi-select') &&
            !hasOptionGroups &&
            !disable
          "
          v-model="query.fromValue"
          :multiple="rule.inputType === 'multi-select'"
          @change="updateQuery"
        >
          <b-option
            v-for="option in selectOptions"
            :key="option.value"
            :value="option.value"
            :label="option.label"
          >
          </b-option>
        </b-select>
        <label
          v-if="
            (rule.inputType === 'select' ||
              rule.inputType === 'multi-select') &&
            !hasOptionGroups &&
            disable
          "
          class="ext-form-label"
          title="Operator"
          >{{ query.fromValue }}</label
        >

        <!-- Select with groups -->
        <!-- <select
          v-if="(rule.inputType === 'select' ||
              rule.inputType === 'multi-select') && hasOptionGroups"
          v-model="query.value"
          class="ext-form-control"
          :multiple="rule.inputType === 'multi-select'"
        >
          <optgroup
            v-for="(option, option_key) in selectOptions"
            :key="option_key"
            :label="option_key"
          >
            <option
              v-for="sub_option in option"
              :key="sub_option.value"
              :value="sub_option.value"
            >
              {{ sub_option.label }}
            </option>
          </optgroup>
        </select> -->
      </div>

      <!-- Remove button -->
      <div v-if="!disable" class="col-auto">
        <b-button-icon semi-danger name="control-minus" @click="removeRule" />
      </div>
    </div>
  </div>
</template>

<script>
import { cloneDeep } from 'lodash'
import { required } from 'vuelidate/lib/validators'
import { objectUtils } from '../../utils/index'

export default {
  name: 'QueryBuilderRule',
  props: {
    rules: {
      type: Array,
      default() {
        return []
      },
    },
    labels: {
      type: Object,
      default() {
        return {}
      },
    },
    depth: {
      type: Number,
      default: 0,
    },

    index: {
      type: Number,
      default: 0,
    },
    value: {
      type: Object,
      default() {
        return {}
      },
    },
    disable: {
      type: Boolean,
      default() {
        return false
      },
    },
  },
  data() {
    return {
      query: cloneDeep(this.value),
      rule: {},
    }
  },
  validations: {
    query: {
      fromValue: {
        required,
      },
    },
  },
  computed: {
    selectOptions() {
      if (typeof this.rule.choices === 'undefined') {
        return {}
      }
      // Nest items to support <optgroup> if the rule's choices have
      // defined groups. Otherwise just return a single-level array
      return this.rule.choices.reduce(function (groups, item, index) {
        const key = item.group
        if (typeof key !== 'undefined') {
          groups[key] = groups[key] || []
          groups[key].push(item)
        } else {
          groups[index] = item
        }
        return groups
      }, {})
    },
    hasOptionGroups() {
      return this.selectOptions.length && Array.isArray(this.selectOptions[0])
    },
    showOperator() {
      return this.rule.operators.find((x) => x.key === this.query.operator)
    },
  },
  beforeMount() {
    this.rule = this.ruleById(this.query.attributeName)
  },
  mounted() {
    if (!this.rule) return

    // Set a default value for these types if one isn't provided already
    if (this.query.fromValue === null) {
      if (this.rule.inputType === 'radio') {
        this.query.fromValue = false
      } else if (this.rule.inputType === 'checkbox') {
        this.query.fromValue = true
      } else if (
        this.rule.inputType === 'select' ||
        this.rule.inputType === 'multi-select'
      ) {
        this.query.fromValue = this.rule.choices[0].value
      }

      this.$emit('input', this.query)
    }

    if (
      this.query.fromValue &&
      typeof this.query.fromValue === 'string' &&
      this.rule.inputType === 'checkbox'
    ) {
      this.query.fromValue = this.query.fromValue.toLowerCase() === 'true'
      this.$emit('input', this.query)
    }
  },
  methods: {
    ruleById(ruleId) {
      let rule = null
      this.rules.forEach(function (value) {
        if (value.name === ruleId) {
          rule = value
          return false
        }
      })
      return rule
    },

    removeRule() {
      this.$emit('deletion', this.index)
    },
    updateQuery() {
      if (this.rule.inputType === 'date') {
        this.query.fromValue = objectUtils.getUTC(this.query.fromValue)
      }

      this.$emit('input', this.query)
    },
  },
}
</script>
